float x, y, last_x, last_y ;// r = rayon
boolean firstTime=true;
int centreY, centreX;// pour placer le cercle au milieu
void setup() {
  size (200, 200);
  smooth();
  background(255);
  stroke(0);
  centreX = width/2; 
  centreY = height/2;
  //cercle(50, 24); 
  // spirale(6, 10, 24,0.5);// spirale
 // rosace(6, 10, 140, 8);// spirale;   3 = 3 pedales,4=8, 5=5 6=12, 7=7,8=16
  rosaceComplexe(6, 10, 140, 0.7,25);// 0.7, 25: magic numbers
}
// radius et nombre des points pour definir le cercle
void cercle( float r, float vertexes) {
  float angleStep = TWO_PI/vertexes;
  for (float angle =0; angle<=TWO_PI; angle+=angleStep) {
    x = centreX + cos(angle)*r;// centreX pour placer le circle au centre
    y = centreY + sin(angle)*r;
    if (!firstTime) line(x, y, last_x, last_y);
    last_x = x;
    last_y = y;
    firstTime = false;
  }
}
// nombre des tours, ecartement progressive
void spirale( float r, int nbrTour, float vertexes, float ecartement ) {
  float angleStep = TWO_PI/vertexes;
  for (float angle = 0; angle<=nbrTour*TWO_PI; angle+=angleStep) {
    r+=ecartement;
    x = centreX + cos(angle)*r;
    y = centreY + sin(angle)*r;
    if (!firstTime) line(x, y, last_x, last_y);
    last_x = x;
    last_y = y;
    firstTime = false;
  }
}
//donne le nombre des petales si pair, le double.. 
void rosace( float r, int nbrTour, float vertexes, int petales ) {
  float angleStep = TWO_PI/vertexes;
  for (float angle = 0; angle<=nbrTour*TWO_PI; angle+=angleStep) {
    r=90*sin(petales*angle);
    x = centreX + cos(angle)*r;
    y = centreY + sin(angle)*r;
    if (!firstTime) line(x, y, last_x, last_y);
    last_x = x;
    last_y = y;
    firstTime = false;
  }
}

void rosaceComplexe( float r, int nbrTour, float vertexes, float magic1, int magic2) {
  float angleStep = TWO_PI/vertexes;
  for (float angle = 0; angle<=nbrTour*TWO_PI; angle+=angleStep) {
    r = 80 * sin(magic1 * angle) + magic2;
    x = centreX + cos(angle) * r;
    y = centreY + sin(angle) * r;
    if (!firstTime) line(x, y, last_x, last_y);
    last_x = x;
    last_y = y;
    firstTime = false;
  }
}

